import { WsApiAction, WsApiRequest, WsApiResponse } from './common';
import { OmitNever } from '../../types/OmitNever';
import { WsApiConnection } from './WsApiConnection';
import { SendResponseResult } from '../server';
export type WsApiRequestHandler<Action extends WsApiAction, Request extends WsApiRequest, Response extends WsApiResponse> = (request: Request & {
    action: Action;
}, responseActions: OmitNever<{
    connection: WsApiConnection;
    sendResponse: [Response] extends [never] ? never : (response: Response) => Promise<SendResponseResult>;
    closeConnection: () => Promise<void>;
}>) => Promise<void>;
